/*
  TIME extension
  (c) 2007 Helge Bahmann <hcb@chaoticmind.net>
  see the file COPYING for terms of redistribution
 */

#ifndef __X11_EXTENSIONS_TIMEPROTO
#define __X11_EXTENSIONS_TIMEPROTO

#include <X11/Xmd.h>

/* requests and replies */

#define xtime_QueryExtension 0
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
} xtimeQueryExtensionReq;
#define sz_xtimeQueryExtensionReq sizeof(xtimeQueryExtensionReq)

typedef struct {
	BYTE type;
	CARD8 pad1;
	CARD16 seqNum B16;
	CARD32 length B32;
	CARD16 version B16;
	CARD16 revision B16;
	CARD32 pad3 B32, pad4 B32, pad5 B32, pad6 B32, pad7 B32;
} xtimeQueryExtensionReply;

#define xtime_CreateClock 16
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
	CARD32 rate;
	CARD32 initialValue;
} xtimeCreateClockReq;
#define sz_xtimeCreateClockReq sizeof(xtimeCreateClockReq)

#define xtime_FreeClock 17
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
} xtimeFreeClockReq;
#define sz_xtimeFreeClockReq sizeof(xtimeFreeClockReq)

#define xtime_StartClock 18
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
} xtimeStartClockReq;
#define sz_xtimeStartClockReq sizeof(xtimeStartClockReq)

#define xtime_StopClock 19
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
} xtimeStopClockReq;
#define sz_xtimeStopClockReq sizeof(xtimeStopClockReq)

#define xtime_GetTime 20
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
} xtimeGetTimeReq;
#define sz_xtimeGetTimeReq sizeof(xtimeGetTimeReq)

#define xtime_CreateScheduler 21
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 clockid;
	CARD32 schedulerid;
} xtimeCreateSchedulerReq;
#define sz_xtimeCreateSchedulerReq sizeof(xtimeCreateSchedulerReq)

#define xtime_FreeScheduler 22
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 schedulerid;
} xtimeFreeSchedulerReq;
#define sz_xtimeFreeSchedulerReq sizeof(xtimeFreeSchedulerReq)

typedef struct {
	BYTE type;
	CARD8 pad1;
	CARD16 seqNum B16;
	CARD32 length B32;
	CARD32 time B32;
	CARD32 pad3 B32, pad4 B32, pad5 B32, pad6 B32, pad7 B32;
} xtimeGetTimeReply;

#define xtime_ScheduleGroup 32
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 schedulerid;
	CARD32 groupid;
	CARD32 begin;
	CARD32 end;
	CARD32 flags;
} xtimeScheduleGroupReq;
#define sz_xtimeScheduleGroupReq sizeof(xtimeScheduleGroupReq)

#define xtime_ReplaceGroup 33
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 schedulerid;
	CARD32 groupid;
} xtimeReplaceGroupReq;
#define sz_xtimeReplaceGroupReq sizeof(xtimeReplaceGroupReq)

#define xtime_CancelGroup 34
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 schedulerid;
	CARD32 groupid;
} xtimeCancelGroupReq;
#define sz_xtimeCancelGroupReq sizeof(xtimeCancelGroupReq)

#define xtime_ClearGroups 35
typedef struct {
	CARD8 reqType;
	CARD8 reqMinorType;
	CARD16 length;
	CARD32 schedulerid;
} xtimeClearGroupsReq;
#define sz_xtimeClearGroupsReq sizeof(xtimeClearGroupsReq)

/* events */

#define Xtime_NEVENTS 1

typedef struct {
	BYTE type;
	BYTE reason;
	CARD16 seqnum B16;
	CARD32 schedulerid B32;
	CARD32 groupid B32;
	CARD32 timestamp B32;
	CARD32 status B32;
	CARD32 pad5 B32, pad6 B32, pad7 B32;
} xtimeTimerEvent;

#define Xtime_NERRORS 0

#endif
